'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var store = void 0;
var subscriptions = [];

function subscribe(subscription) {
  var promiseResolver = void 0;
  var promise = new Promise(function (resolve) {
    promiseResolver = resolve;
  });

  subscriptions = [].concat(babelHelpers.toConsumableArray(subscriptions), [Object.assign({}, subscription, {
    resolve: promiseResolver
  })]);

  return promise;
}

function setStore(s) {
  store = s;

  store.subscribe(function () {
    var newState = store.getState();

    subscriptions = subscriptions.map(function (subscription) {
      if (subscription.predicate(newState)) {
        subscription.resolve(subscription.selector(newState));

        return null;
      }

      return subscription;
    }).filter(Boolean);
  });
}

exports.subscribe = subscribe;
exports.setStore = setStore;
//# sourceMappingURL=index.cjs.js.map
